//Excercise 2: Commands
print("hello You there");

//Excercise 3: Variables
text1 = "hello ";
text2 = "world";
print (text1 + text2);	

scaling=0.5;
run("Scale...", "x="+scaling+" y="+scaling+" interpolation=Bilinear average create title=New-scaled");

scaling=0.5;
options = "x="+scaling+" y="+scaling+" interpolation=Bilinear average create title=New-scaled"; 
run("Scale...", options);


//Excercise 4: Arrays
arrayExample = newArray(0,1,1,2,3,5,8,13,21);
Array.getStatistics(arrayExample, min, max, mean, stdDev); 
print("Min: " + min + " Max: " + max + " Mean: " + mean +" StDev: " + stdDev);
	
arrayExample2 = newArray("Bern", "Fribourg", "Lausanne", "Geneva", "Zurich", "Basel");
sortedArrayExample2 = Array.sort(arrayExample2);
Array.show(sortedArrayExample2);
		
//Excercise 5: Functions
value1=17;
value2=20;
print(sumTheseValues(value1, value2));

function sumTheseValues(one,two){
	summed = one + two;
	// now return the summed value to the print command:
	return summed;
}

//Excercise 6: Comments

/*
The Adolphe Merkle Institute staff follow an ethical charter. 
They respect ethical standards in their behavior at the workplace and act responsibly in planning and
executing their research and teaching.

At AMI, we:

    respect human rights, protect personal information, prevent any kind of harassment and 
    discrimination based on nationality, gender, race, religion, sexual orientation, age 
    or any other reason, and act whenever needed to prevent such behavior;
    
    comply with international rules, applicable laws and regulations, school rules, the spirit
    of such rules, locally accepted societal standards and foster an environment of mutual 
    trust and respect;
    
    teach with integrity, fairness, dignity and honesty and maintain a professional relationship 
    with students;
    
    plan, conduct, document and communicate research and interpret results according to the highest
    international standards;
    
    limit testing on animals, wherever possible and be committed to applying high standards of
    animal welfare and to using animals responsibly;
    
    not accept funding from sources that might lead to influencing of research results or their
    interpretation or lead to a conflict of interest;
    
    not conduct research that has the goal of producing results that can be used to harm humans, 
    animals or the environment or can be anticipated of being misused for the latter;
    
    use resources in a sustainable way and contribute with their research to the same, 
    wherever possible. 
*/

//Excercise 7: The Sobel filter pipeline
sobelFilter("/home/dimitri/servers/bigdata/Teaching/ImageJ course/Test datasets/Advanced/Example 8 - camera man.tif");

function sobelFilter(path) {	
	//Open the image and rename it 
	open(path);
	rename("Original");
	//prepare the horizontal component
	selectWindow("Original");
	run("Duplicate...", "title=horizontal");
	run("Convolve...", "text1=[-1 -2 -1\n0 0 0\n1 2 1\n] normalize");
	run("16-bit");
	run("Square");
	// Prepare the vertical component
	selectWindow("Original");
	run("Duplicate...", "title=vertical");
	run("Convolve...", "text1=[-1 0 1\n-2 0 2\n-1 0 1\n] normalize");
	run("16-bit");
	run("Square");
	// Sum both vertical and horizontal together
	imageCalculator("Add create", "horizontal","vertical");
	selectWindow("Result of horizontal");
	rename("Sobel_Filtered");
	run("Square Root");
	run("Enhance Contrast", "saturated=0.35");
	setMinAndMax(0, 255);
	run("8-bit");	
	//cleanup the intermediate images
	selectWindow("vertical");
	close();
	selectWindow("horizontal");
	close();
	selectWindow("Original");
	close();		
}

open("/home/dimitri/servers/bigdata/Teaching/ImageJ course/Test datasets/Advanced/Example 8 - camera man.tif");

//Excercise 8: Conditional code
value1 = 17;
value2 = 20;
print(checkIfSameValues(value1,value2));

function checkIfSameValues(value1,value2){
//Check if both values are the same	
if(value1!=value2){
	reply = "nope, they are different";
	} else {
		reply = "yep, both are the same";
	}
	return reply;	
}
	
//Excercise 9: For loop 
for(x = 0; x <= 10; x++){
	print(x);
}

//Excercise 10: For loop 
for(x = 0; x <= 10; x+=10){
	print(x);
}

//Excercise 11: While loop 
x = 1;
while (x <= 10){
	print(x);
	x = x + 1;
}		

//Excercise 12: While loop 
x = 11;
while (x <= 10){
	print(x);
	x = x + 1;
}		

//Excercise 13: Do... While loop 
x = 1;
do {
	print(x);
	x = x + 1;
} while (x <= 10);		

//Excercise 14: Do... While loop 
x = 11;
do {
	print(x);
	x = x + 1;
} while (x <= 10);	

//Excercise 15: Invert image
path = "/home/dimitri/servers/bigdata/Teaching/ImageJ course/Test datasets/Advanced/Example 8 - camera man.tif";
open(path);	
run("Select None");
getDimensions(width, height, channels, slices, frames);

for (i=0;i <= width; i++){
	for(j = 0; j <= height; j++){			
		setPixel(i,j,255-getPixel(i,j));
	}
}


//Excercise 16: Median value of a table column
path = "/home/dimitri/servers/bigdata/Teaching/ImageJ course/Advanced Course data/Example 11 - AuNP.tif";
open(path);
setAutoThreshold("Default");
//run("Threshold...");
run("Convert to Mask");

run("Set Measurements...", "area fit feret's display redirect=None");
run("Analyze Particles...", "  show=Nothing display exclude clear");
print("Area of first particle: " + getResult("Area", 0));
print("Number of particles: " + nResults);

summed=0;
values = newArray;
for (e=0;e<nResults;e++){
	summed = summed + getResult("Feret", e);
	values = Array.concat(values, getResult("Feret", e));	
}
Array.sort(values);
print("Mean Feret length: " +summed / nResults); 
print("Median Feret length: " + values[floor(nResults/2)+1]); 
